% Método de Jacobi

% ¿Cómo decido automáticamente si está convergiendo?
% || x^{k+1} - x^{k} || / || x^{k} || pequeño -> converge
% grande -> diverge

Nmax = 10; % Número de iteraciones
tol = 1e-4; % error relativo permitido


A = [5,2,1; -3,6,1; 2,3,5];
%A = [5,2,1; -3,1,1; 2,3,1]; % Dos de la diagonal no "dominan" (no converge)
b = [10; 6; 20];

Ap = A - diag(diag(A));
Dinv = diag(A).^-1;

% Valor inicial
n = size(A,1);
x = zeros(n,1);

% Iteraciones del método de Jacobi
for k = 1:Nmax
    x_old = x;
    x = Dinv .* (b - Ap*x);
    err = norm(x-x_old)/norm(x_old+eps);
    if err < tol
        % Si el error relativo es pequeño
        % acaba sin gastar todas las iteraciones
        disp(['Se han usado ',num2str(k),' iteraciones'])
        disp(['La aproximación de la solución es:'])
        disp(x)
        break
    end
end

disp('Fin del bucle')
