% Contraejemplo: Gauss-Seidel no conrge, Jacobi sí

N = 40;
bet = (5+sqrt(21))/2;
A = [1,1,2; bet,1,1; -5/2,1/bet, 1];
b = A*ones(3,1);

n = size(A,1);

%Jacobi
Ap = A - diag(diag(A));
Dinv = diag(A).^-1;

% Valor inicial
n = size(A,1);
x = rand(n,1);

% Iteraciones del método de Jacobi
for k = 1:N
    x = Dinv .* (b - Ap*x);
end

disp(x)

% Gauss-Seidel
n = size(A,1);
x = rand(n,1);

for k = 1:N
    for ii = 1:n
        x(ii) = (b(ii) - A(ii, 1:ii-1)*x(1:ii-1) - A(ii, ii+1:n)*x(ii+1:n) )/A(ii,ii);
    end
end
disp(x)
